//---------------------------------------------------------------
//
//  Ce code est librement inspiré de celui de Gabriel STOLTZ (Ecole des Ponts)
//
//---------------------------------------------------------------

clf();
xset("fpf"," ");

//-------- modes --------
opt = 0;   // 0 = plot3d standard
           // 2 = surfaces de niveau 3d 
           // 1 = surfaces de niveau 2d

//------ pour les traces -------
dx = 0.05;
dy = 0.05;
dx_c = 0.001;
Rx = 4;
Ry = 4;

//-------- fonction -------------

//a = 1;

function z = V(x,y)
   z = (x^3 + y^2)*exp(-(x^2+y^2));
endfunction

//--------- bornes -------

x=-Rx:dx:Rx;
y=-Ry:dy:Ry;

//-------- trace surface 3D -------------
if (opt == 0)
    
    fplot3d(x,y,V);
    
    //------- options graphiques ---------
    e = gce();
    e.color_flag=1; 
    e.color_mode=-2  // remove the facets boundary by setting color_mode to white color
    a = gca(); //get current axes
    a.rotation_angles=[81,-112];
//    a.axes_visible="off";
//    a.box = "off";
    f = gcf();//get the handle of the parent figure
    f.color_map = jetcolormap(512);
end

//-------- ajouter surfaces de niveau à plot3d ---------
if (opt == 2)
    
    fplot3d(x,y,V);
    e = gce();
    e.color_flag=1; 
    e.color_mode=-2;  // remove the facets boundary by setting color_mode to white color
    f = gcf();//get the handle of the parent figure
    f.color_map = jetcolormap(512);
    
    z = feval(x,y,V);
    contour(x,y,z,20,flag=[0 2 4]);  // flag = mode/scaling/box
    f = gcf();//get the handle of the parent figure
    f.color_map = jetcolormap(512);
    a = gca(); // get current axes
    a.rotation_angles=[77.5,233];
    a.box = "off";
end

//------- trace d'un contour -----------
if (opt == 1)
    
    z = feval(x,y,V);
    contour2d(x,y,z,30,rect=[-Rx,-Ry,Rx,Ry]);
    f = gcf(); // get the handle of the parent figure
    f.color_map = jetcolormap(24);
    a = gca(); //get current axes
    a.isoview = "on";
    
end
